﻿using Syncfusion.UI.Xaml.Charts;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Media;
using System.Windows.Threading;

namespace Sample_WPF
{
    public class ViewModel
    {
        private int seriesCount = 4;

        private int dataCount = 10;

        public ChartSeriesCollection Series { get; set; }

        public ViewModel()
        {
            Series = new ChartSeriesCollection();            
        }         

        public void UpdateSeries()
        {
            Random random = new Random();

            for (int i = 0; i < seriesCount; i++)
            {
                var data = new ObservableCollection<Model>();
                for (int j = 0; j < dataCount; j++)
                {
                    data.Add(new Model(j, random.Next(10, 90)));
                }

                if (Series.Count == 0)
                    Series.Add(new FastLineSeries()
                    {
                        XBindingPath = "XValue",
                        YBindingPath = "Value",
                        ItemsSource = data
                    });
                else
                    Series.Add(new FastLineSeries()
                    {
                        XBindingPath = "XValue",
                        YBindingPath = "Value",
                        ItemsSource = data
                    });
            }
        }
    }

    public class Model : INotifyPropertyChanged
    {
        private double xValue;
        public double XValue
        {
            get { return xValue; }
            set
            {
                if (value != xValue)
                {
                    xValue = value;
                    RaisePropertyChanged(nameof(XValue));
                }
            }
        }

        private double value;
        public double Value
        {
            get { return value; }
            set
            {
                if (value != this.value)
                {
                    this.value = value;
                    RaisePropertyChanged(nameof(Value));
                }
            }
        }

        public Model(double x, double y)
        {
            XValue = x;
            Value = y;
        }

        public event PropertyChangedEventHandler PropertyChanged;

        void RaisePropertyChanged(string name)
        {
            PropertyChanged?.Invoke(this, new PropertyChangedEventArgs(name));
        }
    }
}

